precision mediump float;

uniform vec3      iResolution;           // viewport resolution (in pixels)
uniform float     iDuration;             // shader playback total time (in seconds)
uniform float     iTime;                 // shader playback current time (in seconds)
uniform float     iTimeDelta;            // render time (in seconds)
uniform int       iFrame;                // shader playback frame
uniform float     iChannelTime[8];       // channel playback time (in seconds)
uniform vec3      iChannelResolution[8]; // channel resolution (in pixels)
uniform vec4      iMouse;                // mouse pixel coords. xy: current (if MLB down), zw: click
uniform sampler2D iChannel[8];           // input channel. XX = 2D/Cube
uniform vec4      iDate;                 // (year, month, day, time in seconds)
uniform float     iSampleRate;           // sound sample rate (i.e., 44100)

uniform float     strength;

float iProgress = iTime / iDuration;

vec2 direction = vec2(1.0, 0.0);

float easeInOutQuint(float t) 
{ 
    return t<0.5 ? 16.0*t*t*t*t*t : 1.0+16.0*(--t)*t*t*t*t; 
}

void main() {
	vec2 texCoord = gl_FragCoord.xy / iResolution.xy;
	vec2 uv0 = texCoord;
	
    float mProgress = 1.0 - easeInOutQuint(iProgress);
    if(texCoord.x < mProgress)
        gl_FragColor = texture2D(iChannel[0],texCoord+vec2(1.0-mProgress,0.0));
    else
        gl_FragColor = texture2D(iChannel[1],texCoord-vec2(mProgress,0.0));
		
    //float iTime2 = easeInOutQuint(clamp(iProgress, 0.0, 1.0));
    //vec2 p = uv0 + iTime2*sign(direction);
    //vec2 f = fract(p);
    //vec4 fromTex = texture2D(iChannel[0], f);
    //vec4 toTex = texture2D(iChannel[1], f);
    //vec3 res = mix(toTex.rgb, fromTex.rgb, step(0.0, p.y)*step(p.y, 1.0)*step(0.0, p.x)*step(p.x, 1.0));

    //gl_FragColor = vec4(res, 1.0);
}
